% Name:          inner_intra8x8_test.m
% Author:        Kim Troennes
% Description:   Test of 8x8 inner intra prediction VHDL module
% Last modified: 05.05.2014

clear all
close all
clc

Img = int16(imread('lena64.png'));
Range = [0 255];

%% Initialize
Predicted = int16(zeros(8));
Diff = int16(zeros(8));
SAD = int16(zeros(1,9));
Hor =int16(zeros(8));
Ver =int16(zeros(8));
DC =int16(zeros(8));
DDL =int16(zeros(8));
DDR =int16(zeros(8));
VR=int16(zeros(8));
HD=int16(zeros(8));
VL=int16(zeros(8));
HU=int16(zeros(8));
PredictionMatrices=int16(zeros(8,9*8));
SelectedModes = int16(zeros(1,9));
infinity = 256*64;
midRange = int16(Range(1)+Range(2)/2);

%starting positions: first pixel of the 8x8 frame
% frame 1: i=2, j=2    frame 2: i=2,j=10
% frame 3: i=10,j=2    frame 4: i=10,j=10
%firstcol/row-test: 
%frame 1: i=18,j=29, frame 2: i=18,j=37
%frame 3: i=26,j=29, frame 4: i=26,j=37
i=2;
j=2;

A = Img(i-1,j);
B = Img(i-1,j+1);
C = Img(i-1,j+2);
D = Img(i-1,j+3);
E = Img(i-1,j+4);
F = Img(i-1,j+5);
G = Img(i-1,j+6);
H = Img(i-1,j+7);
I = Img(i-1,j+8);
J = Img(i-1,j+9);
K = Img(i-1,j+10);
L = Img(i-1,j+11);
M = Img(i-1,j+12);
N = Img(i-1,j+13);
O = Img(i-1,j+14);
P = Img(i-1,j+15);
Z = Img(i-1,j-1);
Q = Img(i,j-1);
R = Img(i+1,j-1);
S = Img(i+2,j-1);
T = Img(i+3,j-1);
U = Img(i+4,j-1);
V = Img(i+5,j-1);
W = Img(i+6,j-1);
X = Img(i+7,j-1);

eABC = bitsrl(A+2*B+C+2,2);
eBCD = bitsrl(B+2*C+D+2,2);
eCDE = bitsrl(C+2*D+E+2,2);
eDEF = bitsrl(D+2*E+F+2,2);
eEFG = bitsrl(E+2*F+G+2,2);
eFGH = bitsrl(F+2*G+H+2,2);
eGHI = bitsrl(G+2*H+I+2,2);
eHIJ = bitsrl(H+2*I+J+2,2);
eIJK = bitsrl(I+2*J+K+2,2);
eJKL = bitsrl(J+2*K+L+2,2);
eKLM = bitsrl(K+2*L+M+2,2);
eLMN = bitsrl(L+2*M+N+2,2);
eMNO = bitsrl(M+2*N+O+2,2);
eNOP = bitsrl(N+2*O+P+2,2);
eO3P = bitsrl(O+3*P+2,2);
eZAB = bitsrl(Z+2*A+B+2,2);
eQZA = bitsrl(Q+2*Z+A+2,2);
eRQZ = bitsrl(R+2*Q+Z+2,2);
eSRQ = bitsrl(S+2*R+Q+2,2);
eTSR = bitsrl(T+2*S+R+2,2);
eUTS = bitsrl(U+2*T+S+2,2);
eVUT = bitsrl(V+2*U+T+2,2);
eWVU = bitsrl(W+2*V+U+2,2);
eXWV = bitsrl(X+2*W+V+2,2);
e3XW = bitsrl(3*X+W+2,2);
eAB = bitsrl(A+B+1,1);
eBC = bitsrl(B+C+1,1);
eCD = bitsrl(C+D+1,1);
eDE = bitsrl(D+E+1,1);
eEF = bitsrl(E+F+1,1);
eFG = bitsrl(F+G+1,1);
eGH = bitsrl(G+H+1,1);
eHI = bitsrl(H+I+1,1);
eIJ = bitsrl(I+J+1,1);
eJK = bitsrl(J+K+1,1);
eKL = bitsrl(K+L+1,1);
eZA = bitsrl(Z+A+1,1);
eQZ = bitsrl(Q+Z+1,1);
eRQ = bitsrl(R+Q+1,1);
eSR = bitsrl(S+R+1,1);
eTS = bitsrl(T+S+1,1);
eUT = bitsrl(U+T+1,1);
eVU = bitsrl(V+U+1,1);
eWV = bitsrl(W+V+1,1);
eXW = bitsrl(X+W+1,1);

%% Mode 0 - Horizontal
Hor(1,:) = Q;
Hor(2,:) = R;
Hor(3,:) = S;
Hor(4,:) = T;
Hor(5,:) = U;
Hor(6,:) = V;
Hor(7,:) = W;
Hor(8,:) = X;

%% Mode 1 - Vertical
Ver(:,1) = A;
Ver(:,2) = B;
Ver(:,3) = C;
Ver(:,4) = D;
Ver(:,5) = E;
Ver(:,6) = F;
Ver(:,7) = G;
Ver(:,8) = H;

%% Mode 2 - DC
DC(:,:) = bitsrl(A+B+C+D+E+F+G+H+Q+R+S+T+U+V+W+X+8,4);

%% Mode 3 - DDL
DDL(1,1)=eABC;
DDL(1,2)=eBCD; DDL(2,1)=eBCD;
DDL(1,3)=eCDE; DDL(2,2)=eCDE; DDL(3,1)=eCDE; 
DDL(1,4)=eDEF; DDL(2,3)=eDEF; DDL(3,2)=eDEF; DDL(4,1)=eDEF;
DDL(1,5)=eEFG; DDL(2,4)=eEFG; DDL(3,3)=eEFG; DDL(4,2)=eEFG; DDL(5,1)=eEFG; 
DDL(1,6)=eFGH; DDL(2,5)=eFGH; DDL(3,4)=eFGH; DDL(4,3)=eFGH; DDL(5,2)=eFGH; DDL(6,1)=eFGH;
DDL(1,7)=eGHI; DDL(2,6)=eGHI; DDL(3,5)=eGHI; DDL(4,4)=eGHI; DDL(5,3)=eGHI; DDL(6,2)=eGHI; DDL(7,1)=eGHI; 
DDL(1,8)=eHIJ; DDL(2,7)=eHIJ; DDL(3,6)=eHIJ; DDL(4,5)=eHIJ; DDL(5,4)=eHIJ; DDL(6,3)=eHIJ; DDL(7,2)=eHIJ; DDL(8,1)=eHIJ; 
DDL(2,8)=eIJK; DDL(3,7)=eIJK; DDL(4,6)=eIJK; DDL(5,5)=eIJK; DDL(6,4)=eIJK; DDL(7,3)=eIJK; DDL(8,2)=eIJK;
DDL(3,8)=eJKL; DDL(4,7)=eJKL; DDL(5,6)=eJKL; DDL(6,5)=eJKL; DDL(7,4)=eJKL; DDL(8,3)=eJKL;
DDL(4,8)=eKLM; DDL(5,7)=eKLM; DDL(6,6)=eKLM; DDL(7,5)=eKLM; DDL(8,4)=eKLM;
DDL(5,8)=eLMN; DDL(6,7)=eLMN; DDL(7,6)=eLMN; DDL(8,5)=eLMN;
DDL(6,8)=eMNO; DDL(7,7)=eMNO; DDL(8,6)=eMNO;
DDL(7,8)=eNOP; DDL(8,7)=eNOP;
DDL(8,8)=eO3P;

%% Mode 4 - Diagonal Down Right
DDR(1,8)=eFGH;
DDR(1,7)=eEFG; DDR(2,8)=eEFG;
DDR(1,6)=eDEF; DDR(2,7)=eDEF; DDR(3,8)=eDEF; 
DDR(1,5)=eCDE; DDR(2,6)=eCDE; DDR(3,7)=eCDE; DDR(4,8)=eCDE;
DDR(1,4)=eBCD; DDR(2,5)=eBCD; DDR(3,6)=eBCD; DDR(4,7)=eBCD; DDR(5,8)=eBCD; 
DDR(1,3)=eABC; DDR(2,4)=eABC; DDR(3,5)=eABC; DDR(4,6)=eABC; DDR(5,7)=eABC; DDR(6,8)=eABC;
DDR(1,2)=eZAB; DDR(2,3)=eZAB; DDR(3,4)=eZAB; DDR(4,5)=eZAB; DDR(5,6)=eZAB; DDR(6,7)=eZAB; DDR(7,8)=eZAB; 
DDR(1,1)=eQZA; DDR(2,2)=eQZA; DDR(3,3)=eQZA; DDR(4,4)=eQZA; DDR(5,5)=eQZA; DDR(6,6)=eQZA; DDR(7,7)=eQZA; DDR(8,8)=eQZA; 
DDR(2,1)=eRQZ; DDR(3,2)=eRQZ; DDR(4,3)=eRQZ; DDR(5,4)=eRQZ; DDR(6,5)=eRQZ; DDR(7,6)=eRQZ; DDR(8,7)=eRQZ;
DDR(3,1)=eSRQ; DDR(4,2)=eSRQ; DDR(5,3)=eSRQ; DDR(6,4)=eSRQ; DDR(7,5)=eSRQ; DDR(8,6)=eSRQ;
DDR(4,1)=eTSR; DDR(5,2)=eTSR; DDR(6,3)=eTSR; DDR(7,4)=eTSR; DDR(8,5)=eTSR;
DDR(5,1)=eUTS; DDR(6,2)=eUTS; DDR(7,3)=eUTS; DDR(8,4)=eUTS;
DDR(6,1)=eVUT; DDR(7,2)=eVUT; DDR(8,3)=eVUT;
DDR(7,1)=eWVU; DDR(8,2)=eWVU;
DDR(8,1)=eXWV;

%% Mode 5 - Vertical Right
VR(1,1)=eZA;  VR(1,2)=eAB;  VR(1,3)=eBC;  VR(1,4)=eCD;  VR(1,5)=eDE;  VR(1,6)=eEF;  VR(1,7)=eFG;  VR(1,8)=eGH;
VR(2,1)=eQZA; VR(2,2)=eZAB; VR(2,3)=eABC; VR(2,4)=eBCD; VR(2,5)=eCDE; VR(2,6)=eDEF; VR(2,7)=eEFG; VR(2,8)=eFGH; 
VR(3,1)=eRQZ; VR(3,2)=eZA;  VR(3,3)=eAB;  VR(3,4)=eBC;  VR(3,5)=eCD;  VR(3,6)=eDE;  VR(3,7)=eEF;  VR(3,8)=eFG;
VR(4,1)=eSRQ; VR(4,2)=eQZA; VR(4,3)=eZAB; VR(4,4)=eABC; VR(4,5)=eBCD; VR(4,6)=eCDE; VR(4,7)=eDEF; VR(4,8)=eEFG;
VR(5,1)=eTSR; VR(5,2)=eRQZ; VR(5,3)=eZA;  VR(5,4)=eAB;  VR(5,5)=eBC;  VR(5,6)=eCD;  VR(5,7)=eDE;  VR(5,8)=eEF;
VR(6,1)=eUTS; VR(6,2)=eSRQ; VR(6,3)=eQZA; VR(6,4)=eZAB; VR(6,5)=eABC; VR(6,6)=eBCD; VR(6,7)=eCDE; VR(6,8)=eDEF;
VR(7,1)=eVUT; VR(7,2)=eTSR; VR(7,3)=eRQZ; VR(7,4)=eZA;  VR(7,5)=eAB;  VR(7,6)=eBC;  VR(7,7)=eCD;  VR(7,8)=eDE;
VR(8,1)=eWVU; VR(8,2)=eUTS; VR(8,3)=eSRQ; VR(8,4)=eQZA; VR(8,5)=eZAB; VR(8,6)=eABC; VR(8,7)=eBCD; VR(8,8)=eCDE; 

%% Mode 6 - Horizontal Down
HD(1,1)=eQZ; HD(1,2)=eQZA; HD(1,3)=eZAB;HD(1,4)=eABC; HD(1,5)=eBCD;HD(1,6)=eCDE; HD(1,7)=eDEF;HD(1,8)=eEFG;
HD(2,1)=eRQ; HD(2,2)=eRQZ; HD(2,3)=eQZ; HD(2,4)=eQZA; HD(2,5)=eZAB;HD(2,6)=eABC; HD(2,7)=eBCD;HD(2,8)=eCDE;
HD(3,1)=eSR; HD(3,2)=eSRQ; HD(3,3)=eRQ; HD(3,4)=eRQZ; HD(3,5)=eQZ; HD(3,6)=eQZA; HD(3,7)=eZAB;HD(3,8)=eABC;
HD(4,1)=eTS; HD(4,2)=eTSR; HD(4,3)=eSR; HD(4,4)=eSRQ; HD(4,5)=eRQ; HD(4,6)=eRQZ; HD(4,7)=eQZ; HD(4,8)=eQZA;
HD(5,1)=eUT; HD(5,2)=eUTS; HD(5,3)=eTS; HD(5,4)=eTSR; HD(5,5)=eSR; HD(5,6)=eSRQ; HD(5,7)=eRQ; HD(5,8)=eRQZ;
HD(6,1)=eVU; HD(6,2)=eVUT; HD(6,3)=eUT; HD(6,4)=eUTS; HD(6,5)=eTS; HD(6,6)=eTSR; HD(6,7)=eSR; HD(6,8)=eSRQ;
HD(7,1)=eWV; HD(7,2)=eWVU; HD(7,3)=eVU; HD(7,4)=eVUT; HD(7,5)=eUT; HD(7,6)=eUTS; HD(7,7)=eTS; HD(7,8)=eTSR;
HD(8,1)=eXW; HD(8,2)=eXWV; HD(8,3)=eWV; HD(8,4)=eWVU; HD(8,5)=eVU; HD(8,6)=eVUT; HD(8,7)=eUT; HD(8,8)=eUTS;

%% Mode 7 -Vertical Left
VL(1,1)=eAB;  VL(1,2)=eBC;  VL(1,3)=eCD;  VL(1,4)=eDE;  VL(1,5)=eEF;  VL(1,6)=eFG;  VL(1,7)=eGH;  VL(1,8)=eHI;
VL(2,1)=eABC; VL(2,2)=eBCD; VL(2,3)=eCDE; VL(2,4)=eDEF; VL(2,5)=eEFG; VL(2,6)=eFGH; VL(2,7)=eGHI; VL(2,8)=eHIJ;
VL(3,1)=eBC;  VL(3,2)=eCD;  VL(3,3)=eDE;  VL(3,4)=eEF;  VL(3,5)=eFG;  VL(3,6)=eGH;  VL(3,7)=eHI;  VL(3,8)=eIJ;
VL(4,1)=eBCD; VL(4,2)=eCDE; VL(4,3)=eDEF; VL(4,4)=eEFG; VL(4,5)=eFGH; VL(4,6)=eGHI; VL(4,7)=eHIJ; VL(4,8)=eIJK;
VL(5,1)=eCD;  VL(5,2)=eDE;  VL(5,3)=eEF;  VL(5,4)=eFG;  VL(5,5)=eGH;  VL(5,6)=eHI;  VL(5,7)=eIJ;  VL(5,8)=eJK;
VL(6,1)=eCDE; VL(6,2)=eDEF; VL(6,3)=eEFG; VL(6,4)=eFGH; VL(6,5)=eGHI; VL(6,6)=eHIJ; VL(6,7)=eIJK; VL(6,8)=eJKL;
VL(7,1)=eDE;  VL(7,2)=eEF;  VL(7,3)=eFG;  VL(7,4)=eGH;  VL(7,5)=eHI;  VL(7,6)=eIJ;  VL(7,7)=eJK;  VL(7,8)=eKL;
VL(8,1)=eDEF; VL(8,2)=eEFG; VL(8,3)=eFGH; VL(8,4)=eGHI; VL(8,5)=eHIJ; VL(8,6)=eIJK; VL(8,7)=eJKL; VL(8,8)=eKLM;

%% Mode 8 - Horizontal Up
HU(1,1)=eRQ; HU(1,2)=eSRQ; HU(1,3)=eSR; HU(1,4)=eTSR; HU(1,5)=eTS; HU(1,6)=eUTS; HU(1,7)=eUT; HU(1,8)=eVUT;
HU(2,1)=eSR; HU(2,2)=eTSR; HU(2,3)=eTS; HU(2,4)=eUTS; HU(2,5)=eUT; HU(2,6)=eVUT; HU(2,7)=eVU; HU(2,8)=eWVU;
HU(3,1)=eTS; HU(3,2)=eUTS; HU(3,3)=eUT; HU(3,4)=eVUT; HU(3,5)=eVU; HU(3,6)=eWVU; HU(3,7)=eWV; HU(3,8)=eXWV;
HU(4,1)=eUT; HU(4,2)=eVUT; HU(4,3)=eVU; HU(4,4)=eWVU; HU(4,5)=eWV; HU(4,6)=eXWV; HU(4,7)=eXW; HU(4,8)=e3XW;
HU(5,1)=eVU; HU(5,2)=eWVU; HU(5,3)=eWV; HU(5,4)=eXWV; HU(5,5)=eXW; HU(5,6)=e3XW; HU(5,7)=X;   HU(5,8)=X;
HU(6,1)=eWV; HU(6,2)=eXWV; HU(6,3)=eXW; HU(6,4)=e3XW; HU(6,5)=X;   HU(6,6)=X;    HU(6,7)=X;   HU(6,8)=X;
HU(7,1)=eXW; HU(7,2)=e3XW; HU(7,3)=X;   HU(7,4)=X;    HU(7,5)=X;   HU(7,6)=X;    HU(7,7)=X;   HU(7,8)=X;
HU(8,:)=X;

%% Calculate SADs
PredictionMatrices=[Hor Ver DC DDL DDR VR HD VL HU];
SAD=zeros(1,9);
SAD(1) = sum(sum(abs(Hor -Img(i:i+7,j:j+7))));
SAD(2) = sum(sum(abs(Ver -Img(i:i+7,j:j+7))));
SAD(3) = sum(sum(abs(DC - Img(i:i+7,j:j+7))));
SAD(4) = sum(sum(abs(DDL -Img(i:i+7,j:j+7))));
SAD(5) = sum(sum(abs(DDR -Img(i:i+7,j:j+7))));
SAD(6) = sum(sum(abs(VR - Img(i:i+7,j:j+7))));
SAD(7) = sum(sum(abs(HD - Img(i:i+7,j:j+7))));
SAD(8) = sum(sum(abs(VL - Img(i:i+7,j:j+7))));
SAD(9) = sum(sum(abs(HU - Img(i:i+7,j:j+7))));
[MinSAD,Pos] = min(SAD);
SelectedModes(Pos) = SelectedModes(Pos)+1;
Predicted = PredictionMatrices(:,(Pos-1)*8+1:(Pos-1)*8+8);
Diff = Img(i:i+7,j:j+7) - Predicted + midRange;

figure;
subplot(1,3,1), imshow(Img(i:i+7,j:j+7),Range), title('Original');
subplot(1,3,2), imshow(Predicted,Range), title('Predicted');
subplot(1,3,3), imshow(Diff,Range), title('Residual');

figure;
imshow(Img,Range), title('Whole image');

disp('Inputs and outputs for:');
disp(['An 8x8 frame starting at position ' num2str(i) ',' num2str(j)]);
disp('A-Z:');
disp([A B C D E F G H I J K L M N O P Q R S T U V W X Z]);
disp('Input 8x8');
disp(Img(i:i+7,j:j+7));
disp('     Hor,  Ver,  DC,   DDL,   DDR,  VR,  HD,   VL,   HU');
disp(['SADs:' num2str(SAD)]);
disp('Predicted pixels:');
disp(Predicted);
disp('Differences/Residuals:');
disp(Diff-midRange);